SystemOrganization addCategory: #'Ring-History-Browsers'!

!RGReferenceHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/5/2011 15:40'!
labelForView

	^ self target name ! !

!RGInvocationHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/21/2011 15:13'!
labelForView

	^ self senderName ! !

!RGTBehaviorHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 9/9/2011 13:16'!
canBeVisualized
	"The receiver can be visualized if it a non-external class or if its a extendedClass (which it this case doesn mater if is external)"

	^ self isExternal not or:[ self isExtendedClass ]! !

!RGTHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 9/21/2011 15:49'!
colorByStatus

	self wasReintroduced ifTrue: [ ^Color yellow ].
	self wasAdded ifTrue: [ ^Color green ].
	self wasRemoved ifTrue: [ ^Color red ].
	self wasMerged ifTrue: [ ^Color orange ].
	self wasModified ifTrue: [ ^Color blue ].
	^Color white! !

!RGTHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 9/16/2011 08:08'!
iconByStatus

	self wasAdded ifTrue:[ ^RGMenuIcons addIcon ].
	self wasRemoved ifTrue:[ ^RGMenuIcons deleteIcon ].
	self wasModified ifTrue:[ ^RGMenuIcons editIcon ].
	
	^MenuIcons blankIcon! !

!RGTHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 9/16/2011 08:26'!
nameWithTime

	^self fullName, ' (', self firstVersion timeStamp asString, ')'! !

!RGTHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/6/2011 12:52'!
viewVersionHistory
	| view |
	view := MOViewRenderer title: 'History of #', self nameWithTime.
	self viewVersionHistoryOn: view.
	^ view open! !

!RGTHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/5/2011 14:07'!
viewVersionHistoryOn: view
	| nodes |
	nodes := self withAllPredecessors.

	view nodeShape
		withoutBorder;
		fillColor: [ :e| Color white ].
	view node: self forIt:[ 	
		view nodeShape 
			size: 10;
			fillColor:[ :e| e colorByStatus ].
		view interaction popupText: [ :each| each nameWithTime ].
	"	view interaction forward.
		view interaction 
			registerForEvent: MOElementSelection
			forNodes: [:v | nodes ]
			updateShape: [:shape | ]
			updateLayout: false.
		view interaction 
			registerForEvent: MOElementDeselection
			forNodes: [:v | nodes ]
			updateShape: [:shape | ]
			updateLayout: false."
	
		view nodes: nodes.
		view edges: nodes
			from: [ :each | each ] 
			toAll: [ :each | each predecessors ].
		view dominanceTreeLayout ]! !

!RGMissingPackageNode methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/8/2011 17:10'!
borderColorNode

	^self colorNode! !

!RGMissingPackageNode methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/9/2011 14:32'!
colorNode

	^Color red! !

!RGRemovedHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/10/2011 10:41'!
borderColor

	(self firstVersion wasHistoryAdded: self) ifTrue: [ ^ RGColor addedMethod ].
	(self firstVersion wasHistoryRemoved: self) ifTrue: [ ^ RGColor removedMethod ].
"	self modifiedConditionColor ifTrue: [ ^ RGColor modifiedSourceCode ]."
	
	^ RGColor darkGray! !

!RGRemovedHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/10/2011 10:49'!
borderStyle
	
	^self isExtension
		ifTrue: [ BorderStyle dashed dashColors: {self borderColor . RGColor white } ]
		ifFalse:[ BorderStyle simple ]! !

!RGRemovedHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 9/8/2011 18:45'!
canBeVisualized

	^ true! !

!RGRemovedHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/10/2011 10:44'!
nodeHeaderSourceCodeOn: view
	| headerShape header1 header2 width |

	headerShape := 
		RGLabelShape mediumFont
			text: [ :each | each ];
			withoutBorder;
			withBackground.
	header1 := (self scopeLabel, ' method   {', self protocol, '}   ', self stamp).
	header2 := self firstVersion timeStamp.
	width := headerShape widthOfText: header1.
	
	view nodeShape 
		borderColor:[ :each| each borderColor ];
		borderStyle:[ :each| each borderStyle ].
	view noInteraction.
	view node: self forIt:[
		view node: header1 using: headerShape.
		headerShape 
			textAlignment: #right;
			width: width.
		view node: header2 using: headerShape.
		view verticalLineLayout verticalGap: 2 ].
	^ width - 2! !

!RGRemovedHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/10/2011 10:47'!
viewSourceCodeDiffTo: aRGHistory
	| view |
	
	view := MOViewRenderer title: 'Diff to ', self successors first firstVersion timeStamp asString.
	self viewSourceCodeOn: view diffTo: aRGHistory.
	view open! !

!RGRemovedHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/8/2011 10:48'!
viewSourceCodeOn: view
	
	self nodeHeaderSourceCodeOn: view! !

!RGCommitNode methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/9/2011 11:36'!
borderColorNode

	^Color black! !

!RGCommitNode methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/9/2011 14:31'!
borderColorNode:  aCollection

	^(aCollection detect:[ :each| each = self ] ifNone:[ nil ])
		ifNil: [ self borderColorNode ]
		ifNotNil:[ Color magenta ]! !

!RGCommitNode methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/9/2011 14:16'!
colorNode: selectedCommit successor: selectedSuccessor 

	^self = selectedCommit
		ifTrue: [ Color cyan ]
		ifFalse:[ 
			self = selectedSuccessor
				ifTrue: [ Color magenta ]
				ifFalse:[ Color transparent ] ]! !

!RGMethodAssociationsDiff methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/10/2011 13:55'!
viewAssociationsDiffMap
	| nodes view subNodes |
	
	view := MOViewRenderer title: source fullName, ' (diff from ', source lookupVersion timeStamp asString, ' to ', target lookupVersion timeStamp asString, ')'.
	nodes := {#invocations . #accesses . #references}.			
	
	view nodeShape withoutBorder.
	view nodes: nodes forEach:[ :each|
		| added removed |
		each = #invocations ifTrue: [
			added := self addedInvocations.
			removed := self removedInvocations ].
		each = #accesses ifTrue: [
			added := self addedAccesses.
			removed := self removedAccesses ].
		each = #references ifTrue: [
			added := self addedReferences.
			removed := self removedReferences ].
		view nodeShape 
			text: [ :e| each ].
		(added isEmpty and:[ removed isEmpty ])
			ifFalse:[ view node: target ].
		view nodeShape
			text: [ :e| e labelForView ];
			height: 15;
			borderColor: [ :e | Color green ].
		view nodes: added.
		view nodeShape
			text: [ :e| e labelForView ];
			height: 15;
			borderColor: [ :e | Color red ].
		view nodes: removed.
		view edgeFrom: target toAll: added.
		view edgeFrom: target toAll: removed.
		view treeLayout ].
	view verticalLineLayout.
	^ view open! !

!RGMethodAssociationsDiff methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/5/2011 16:07'!
viewDiffMap
	| nodes view subNodes |
	
	view := MOViewRenderer title: source fullName, ' (diff from ', source lookupVersion timeStamp asString, ' to ', target lookupVersion timeStamp asString, ')'.
	nodes := {#invocations . #accesses . #references}.			
	
	view nodeShape withoutBorder.
	view nodes: nodes forEach:[ :each|
		| added removed |
		each = #invocations ifTrue: [
			added := self addedInvocations.
			removed := self removedInvocations ].
		each = #accesses ifTrue: [
			added := self addedAccesses.
			removed := self removedAccesses ].
		each = #references ifTrue: [
			added := self addedReferences.
			removed := self removedReferences ].
		view nodeShape 
			text: [ :e| each ].
		(added isEmpty and:[ removed isEmpty ])
			ifFalse:[ view node: target ].
		view nodeShape
			text: [ :e| e labelForView ];
			height: 15;
			borderColor: [ :e | Color green ].
		view nodes: added.
		view nodeShape
			text: [ :e| e labelForView ];
			height: 15;
			borderColor: [ :e | Color red ].
		view nodes: removed.
		view edgeFrom: target toAll: added.
		view edgeFrom: target toAll: removed.
		view treeLayout ].
	view verticalLineLayout.
	^ view open! !

!RGPackageHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/10/2011 14:25'!
summary

	self isExternal ifTrue: [ ^ '' ].
	^ String streamContents: [:s |
		s
			nextPutAll: 'Version: '; 
			nextPutAll: self versionName asString; cr; 
			nextPutAll: 'Author: '; 
			nextPutAll: self author asString; cr; 
			nextPutAll: 'Timestamp: ';
			nextPutAll: self timeStamp asString; cr; 
			nextPutAll: 'Ancestors: ';
			nextPutAll: self predecessorVersions; cr; 
			nextPutAll: 'Repository: '; 
			nextPutAll: self repositoryLocation asString; cr; cr;
			nextPutAll: self commitMessage asString ]! !

!RGPackageHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 9/21/2011 15:36'!
visibleClasses
	"Retrieves classes that can be drawn and presented in browsers"

	^(self definedClasses, self removedClasses, self movedClasses)
		select:[ :each | each canBeVisualized ]! !

!RGChange methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/10/2011 16:11'!
icon

	self isAddition ifTrue: [ ^ RGMenuIcons addIcon ].
	self isRemoval ifTrue: [ ^ RGMenuIcons deleteIcon ].
	self isModification ifTrue: [ ^ RGMenuIcons editIcon ].
	^RGMenuIcons blankIcon ! !

!MOViewRenderer methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/3/2011 14:53'!
edgeFrom: aFromBlock to: aToBlock using: aShape
	
	^self edges: self domain from: aFromBlock to: aToBlock using: aShape! !

!MOViewRenderer methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 9/29/2011 12:49'!
edgeFrom: aFromBlock toAll: aToBlock
	
	^self edges: self domain from: aFromBlock toAll: aToBlock! !

!RGCommitGraph methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/22/2011 17:01'!
viewCommitGraph: view selectedCommit: selectedCommit selectedSuccessor: selectedSuccessor
	
	view nodeShape
		borderColor: [ :each| each borderColorNode: (selectedCommit ifNil:[ #() ] ifNotNil:[ :s| s successors ]) ];
		fillColor:[ :each| each colorNode: selectedCommit successor: selectedSuccessor ].
	view nodes: self commitNodes forEach:[ :commit|
		view nodeShape
			borderColor:[ :each| each borderColorNode ];
			fillColor:[ :each| each colorNode ]. 
		view nodes: commit packages.
		view flowLayout maxWidth: 40 ].
	view edges: self commitNodes from: [ :n| n ] toAll:[ :n | n successors ].
	view horizontalDominanceTreeLayout 
		verticalGap: 8! !

!RGPackageNode methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/13/2011 21:11'!
borderColorNode

	^self isExternal
		ifTrue: [ Color purple ]
		ifFalse:[ Color black ]! !

!RGPackageNode methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/13/2011 21:11'!
colorNode

	^self isExternal
		ifTrue: [ Color purple ]
		ifFalse:[ Color white ]! !

!RGRepositorySnapshot methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 9/23/2011 09:17'!
viewComparativeClassesHistoryOn: view selectedEntities: packagesOrClasses
	| predecCollection classIDs classCollection packageIDs forEdges sortedClassNames classes |
	
	predecCollection := self withAllPredecessors.
	packageIDs := OrderedCollection new.
	classIDs := Dictionary new.
	classes := Dictionary new.
	
	packagesOrClasses do:[ :each|
		(each isClass or:[ each isTrait ]) ifTrue: [ 
			classIDs at: each name put: each historyID ].
		each isPackage ifTrue: [ 
			each lookupVersion: self. 
			packageIDs add: each historyID.
			classIDs := classIDs,  each definedClassIDs, each removedDefinedClassIDs, each movedDefinedClassIDs ] ].
	sortedClassNames := classIDs keys sort: self sortByName.
	classIDs keysAndValuesDo:[ :k :v | | c |
		c := self historyWrapperAtIDEvenIfRemoved: v.
		c canBeVisualized 
			ifTrue: [ classes at: k put: c withAllUnwrappedPredecessors ] ]. 
	
	view nodeShape withoutBorder.
	view noInteraction.
	view node: nil forIt: [
	predecCollection do:[ :pred|
		view nodeShape
			borderColor: [ :each| Color lightGray ]; 
			borderStyle: [ :each| BorderStyle dashed ].
		view node: pred forIt:[
			| clsNode hasBorder |
			sortedClassNames do:[ :className|
				view nodeShape size: 10.				
				hasBorder := false.
				clsNode := nil.
				classes at: className ifPresent:[ :col| clsNode := col detect:[ :p| p firstVersion = pred ] ifNone:[ nil ] ].		
				clsNode notNil ifTrue: [
					clsNode := pred thisHistoryEvenIfRemoved: clsNode.
					packageIDs isEmpty ifFalse:[
						(packageIDs includes: clsNode package historyID) 
							ifFalse:[ clsNode := nil  ] ] ].
				clsNode notNil
					ifTrue: [ hasBorder := true.
						      view nodeShape fillColor:[ :e| e colorByStatus ] ].
				hasBorder 
					ifFalse:[ 
						view nodeShape withoutBorder.
						view noInteraction ].
				view node: clsNode ].
			view horizontalLineLayout ].
		
		view verticalLineLayout  ] ].

	classes do:[ :collection|
		 view edges: collection
			from: [ :each | each ] 
			toAll: [ :each | each unwrappedSuccessors ] ].
	view horizontalDominanceTreeLayout.! !

!RGRepositorySnapshot methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 9/21/2011 15:28'!
visibleClasses 
	"Retrieves classes that can be drawn and presented in browsers"
	| classes |
	
	classes := self resolveCollectionWithRemovals: (self classIDs values).
	^ classes select:[ :each| each canBeVisualized ]! !

!RGAccessHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 11/8/2011 12:09'!
labelForView

	^ self keyName! !

!RGSnapshotNode methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/9/2011 16:55'!
borderColorNode

	^Color black! !

!RGSnapshotNode methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/9/2011 16:55'!
borderColorNode:  aCollection

	^(aCollection detect:[ :each| each = self ] ifNone:[ nil ])
		ifNil: [ self borderColorNode ]
		ifNotNil:[ Color magenta ]! !

!RGSnapshotNode methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/9/2011 16:54'!
colorNode: selectedCommit successor: selectedSuccessor 

	^self = selectedCommit
		ifTrue: [ Color cyan ]
		ifFalse:[ 
			self = selectedSuccessor
				ifTrue: [ Color magenta ]
				ifFalse:[ Color transparent ] ]! !

!RGSnapshotNode methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/22/2011 17:46'!
nonCommitPackages

	^packages difference: commit packages! !

!RGMethodHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/10/2011 10:24'!
borderColor

	(self firstVersion wasHistoryAdded: self) ifTrue: [ ^ RGColor addedMethod ].
	(self firstVersion wasHistoryRemoved: self) ifTrue: [ ^ RGColor removedMethod ].
"	self modifiedConditionColor ifTrue: [ ^ RGColor modifiedSourceCode ]."
	
	^ RGColor darkGray! !

!RGMethodHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/10/2011 10:49'!
borderStyle
	
	^self isExtension
		ifTrue: [ BorderStyle dashed dashColors: {self borderColor . RGColor white } ]
		ifFalse:[ BorderStyle simple ]! !

!RGMethodHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/11/2011 10:56'!
drawingSourceCodeOf: source
	| stream |

	stream := ''.
	source linesDo: [ :line|
		stream notEmpty
			ifTrue: [ stream := stream, Character cr asString ].
		line do:[ :each |
			each = Character tab
				ifTrue: [ stream := stream, '    ' ]
				ifFalse:[ stream := stream, each asString ] ] ].
	^ stream! !

!RGMethodHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/10/2011 10:38'!
nodeHeaderSourceCodeOn: view
	| headerShape header1 header2 width |

	headerShape := 
		RGLabelShape mediumFont
			text: [ :each | each ];
			withoutBorder;
			withBackground.
	header1 := (self scopeLabel, ' method   {', self protocol, '}   ', self stamp).
	header2 := self firstVersion timeStamp.
	width := headerShape widthOfText: header1.
	
	view nodeShape 
		borderColor:[ :each| each borderColor ];
		borderStyle:[ :each| each borderStyle ].
	view noInteraction.
	view node: self forIt:[
		view node: header1 using: headerShape.
		headerShape 
			textAlignment: #right;
			width: width.
		view node: header2 using: headerShape.
		view verticalLineLayout verticalGap: 2 ].
	^ width - 2! !

!RGMethodHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/10/2011 10:05'!
sourceCodeColor: symbol forText: aBoolean

	symbol == #insert ifTrue: [ 
		^ aBoolean
			  ifTrue: [ RGColor darkestGreen ]
			  ifFalse:[ RGColor addedMethod ] ].
	
	symbol == #remove ifTrue: [ ^ RGColor removedMethod ].
	
	aBoolean ifTrue: [ ^ RGColor black ].
	
	^ RGColor unchanged! !

!RGMethodHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/10/2011 10:23'!
sourceCodeColorForText: aBoolean

	(self firstVersion wasHistoryAdded: self) ifTrue: [ 
		^ aBoolean 
		      ifTrue: [ RGColor darkestGreen ]
			ifFalse:[ RGColor addedMethod ] ].
	
	(self firstVersion wasHistoryRemoved: self) ifTrue: [ ^ RGColor removedMethod ].
	
	aBoolean ifTrue: [ ^ RGColor black ].
	
	^ RGColor unchanged! !

!RGMethodHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/10/2011 10:09'!
sourceCodeLightColor

	self wasAdded ifTrue: [ ^ RGColor addedComment ].
	
	self wasRemoved ifTrue: [ ^ RGColor removedComment ].
	
	^ RGColor unchanged! !

!RGMethodHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/10/2011 10:04'!
sourceCodeLightColor: symbol forText: aBoolean

	symbol == #insert
	ifTrue:[ ^RGColor addedComment ].
	
	symbol == #remove
	ifTrue:[ ^RGColor removedComment ].
	
	^RGColor unchanged! !

!RGMethodHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/5/2011 14:01'!
viewImplementorsMap
	| nodes implementors view wrapper viewNodes |
	
	nodes := OrderedCollection new.
	implementors := self implementors.
	wrapper := self asHistoryWrapper: self lookupVersion.
	nodes add: wrapper; addAll: implementors.
	view := MOViewRenderer title: 'Implementors of #', self selector.
	view nodeShape 
		text:[ :e| e name ];
		fillColor:[ :e| e colorByStatus ].	
	view interaction 
		popupView: [ :entity :myView | entity viewVersionHistoryOn: myView ] delay: 50;
		highlightWhenOver.
	view interaction on: MOMouseDouble do: [ :ann | 
		ann model isMethod 
			ifTrue: [ ann model viewImplementorsWithHistoryMap ] ].
	viewNodes := view nodes: nodes.
	view edgeFrom: [ wrapper ] toAll: [ implementors ].
	implementors size > 8
		ifTrue: [ view layout: (MOCircleLayout forNodes: viewNodes allButFirst) ]
		ifFalse:[ view treeLayout ].
	^view open! !

!RGMethodHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/5/2011 13:55'!
viewImplementorsWithHistoryMap
	| nodes implementors view wrapper |
	
	nodes := OrderedCollection new.
	wrapper := self asHistoryWrapper: self lookupVersion.
	implementors := self implementors.
	nodes add: wrapper; addAll: implementors.

	view := MOViewRenderer title: 'Implementors Evolution of #', self selector.
	view interaction 
		whenClickingUpdateNode: [ :node|
			view nodeShape 
				withoutBorder;
				text:[ :e| node fullName ].
			view interaction forwarder.
			view node: node ] 
		whenClickingBackUpdateNode:  [:node | 
			node viewVersionHistoryOn: view ]  
		withLayoutUpdate: true. 	
		
	view nodes: nodes forEach:[ :node| 
		node viewVersionHistoryOn: view ].
	view edgeFrom: [ wrapper ] toAll: [ implementors ].
	view treeLayout.
	^ view open! !

!RGMethodHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/5/2011 14:01'!
viewSendersMap
	| nodes senders view wrapper edgeToYourself viewNodes |
	
	edgeToYourself := false.
	wrapper := self asHistoryWrapper: self lookupVersion.
	nodes := OrderedCollection with: wrapper.
	senders := self senders.

	(senders includes: wrapper) 
		ifTrue: [ edgeToYourself := true. 
				senders := senders difference: { wrapper } ].
	nodes addAll: senders.
	edgeToYourself ifTrue: [ nodes add: wrapper ].
	
	view := MOViewRenderer title: 'Senders of #', self fullName.
	view nodeShape 
		text:[ :e| e selector ];
		fillColor:[ :e| e colorByStatus ].
	
	view interaction 
		popupView: [ :entity :myView | entity viewVersionHistoryOn: myView ] delay: 50;
		highlightWhenOver.
	view interaction on: MOMouseDouble do: [ :ann | 
		ann model viewSendersWithHistoryMap ].
		
	viewNodes := view nodes: nodes.
	edgeToYourself
		ifTrue: [ view addEdgeFromNode: viewNodes first toNode: viewNodes last ].
	view edgeFrom: [ wrapper ] toAll: [ senders ].
	senders size > 8
		ifTrue: [ view layout: (MOCircleLayout forNodes: viewNodes allButFirst) ]
		ifFalse:[ view treeLayout ].
	^ view open! !

!RGMethodHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/5/2011 13:53'!
viewSendersWithHistoryMap
	| nodes senders view wrapper |
	
	wrapper := self asHistoryWrapper: self lookupVersion.
	nodes := OrderedCollection with: wrapper.
	senders := self senders.
	
	(senders includes: wrapper) 
		ifTrue: [ senders := senders difference: { wrapper } ].
	nodes addAll: senders.
			
	view := MOViewRenderer title: 'Senders Evolution of #', self fullName.
	view interaction 
		whenClickingUpdateNode: [ :node|
			view nodeShape 
				withoutBorder;
				text:[ :e| node fullName ].
			view interaction forwarder.
			view node: node ] 
		whenClickingBackUpdateNode:  [:node | 
			node viewVersionHistoryOn: view ]  
		withLayoutUpdate: true. 	
		
	view nodes: nodes forEach:[ :node| 
		view interaction forward.
		node viewVersionHistoryOn: view ].
	view edgeFrom: [ wrapper ] toAll: [ senders ].
	view treeLayout.
	^ view open! !

!RGMethodHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/21/2011 15:14'!
viewSourceCodeDetails
	| browser |
	
	browser := GLMTabulator new.
	browser title: self nameWithTime.
	browser 
		row:[ :r| r column: #invocations; column: #accesses; column: #references.];
		row: #sourceCode.
	browser transmit to: #sourceCode; andShow: [:a | 
		a  text
			display: [ :mth| mth sourceCode ];
			forSmalltalk: [ :mth| mth parent ] ].
	browser transmit to: #invocations; andShow: [:a | 
		a title: 'Invocations'.
		a  list
			display: [ :mth| mth invocations sort: self sortByName ];
			format:[ :each| each message ];
			when: [ :mth| mth invocations notEmpty ] ].
	browser transmit to: #accesses; andShow: [:a | 
		a title: 'Accesses'.
		a list				
			display: [ :mth| mth accesses sort: self sortByName ];
			format:[ :each| each labelForView ];
			when: [ :mth| mth accesses notEmpty ] ].
	browser transmit to: #references; andShow: [:a | 
		a title: 'References'.
		a list
			display: [ :mth| mth references sort: self sortByName ];
			format:[ :each| each target name ];
			when: [ :mth| mth references notEmpty ] ].
	^browser openOn: self! !

!RGMethodHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/10/2011 10:47'!
viewSourceCodeDiffTo: aRGHistory
	| view |
	
	view := MOViewRenderer title: 'Diff to ', self successors first firstVersion timeStamp asString.
	self viewSourceCodeOn: view diffTo: aRGHistory.
	view open! !

!RGMethodHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/10/2011 10:17'!
viewSourceCodeOn: view
	
	self viewSourceCodeOn: view diffTo: nil! !

!RGMethodHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/21/2011 12:38'!
viewSourceCodeOn: view diffTo: aRGHistory
	| code nodes fontColor fillColor borderColor borderStyle widthHeader |
	
	aRGHistory notNil
		ifTrue: [ 
			code := [ :line| "self drawingSourceCodeOf: "line value ].
			nodes := self sourceCodeDiffTo: aRGHistory.
			fontColor := [ :line| self sourceCodeColor: line key forText: true ].
			fillColor := [ :line| self sourceCodeLightColor: line key forText: true ].
			borderColor := [ :meth| aRGHistory borderColor ].
			borderStyle := [ :meth| aRGHistory borderStyle ].
			widthHeader:= aRGHistory nodeHeaderSourceCodeOn: view. ]
		ifFalse:[	
			code := [ :meth| "self drawingSourceCodeOf: "meth sourceCode ].
			nodes := { self }.
			fontColor := [ :meth| meth sourceCodeColorForText: true ].
			fillColor := [ :meth| meth sourceCodeLightColor ].
			borderColor := [ :meth| meth borderColor ].
			borderStyle := [ :meth| meth borderStyle ].
			widthHeader:= self nodeHeaderSourceCodeOn: view ].
	
	view nodeShape
 		width: widthHeader;
		borderColor: borderColor;
		borderStyle: borderStyle;
		borderWidth: 2.
	view node: self forIt:[	
		view nodeShape 
			withoutBorder
			text: code;
			fontColor: fontColor;
			fillColor: fillColor;
			fontSize: 8.
		view nodes: nodes.
		view verticalLineLayout
			verticalGap: 0 ].
		
	view verticalLineLayout
		 verticalGap: -1! !

!RGMethodHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/10/2011 13:55'!
viewVersionHistoryOn: view
	| nodes |
	nodes := self withAllPredecessors.

	view nodeShape
		withoutBorder;
		fillColor: [ :e| Color white ].
	view node: self forIt:[ 	
		view nodeShape 
			size: 10;
			fillColor:[ :e| e colorByStatus ].
		view interaction 
			popupText: [ :each| each nameWithTime ];
			popupView: [ :each :popupView | each entity viewSourceCodeOn: popupView ];
			on: MOMouseDouble do: [ :ann | ann model viewSourceCodeDetails ].
		
		view interaction 
			item: [ :each | 
				each successors notEmpty
					ifTrue: [ 'Diff to ', each successors first firstVersion timeStamp asString ]
					ifFalse:[ 'Diff not available' ] ]
			action:[ :each| 
				each successors notEmpty 
					ifTrue: [ (each associationsDiffTo: each successors first) viewAssociationsDiffMap ] ].
		
	"	view interaction forward.
		view interaction 
			registerForEvent: MOElementSelection
			forNodes: [:v | nodes ]
			updateShape: [:shape | ]
			updateLayout: false.
		view interaction 
			registerForEvent: MOElementDeselection
			forNodes: [:v | nodes ]
			updateShape: [:shape | ]
			updateLayout: false."
	
		view nodes: nodes.
		view interaction 
			popupView: [ :each :popupView | 
				(each isKindOf: Association)
					ifTrue: [ each value viewSourceCodeOn: popupView diffTo: each key ]
					ifFalse:[ each entity viewSourceCodeOn: popupView ] ].
		view edges: nodes
			from: [ :each | each ] 
			toAll: [ :each | each predecessors ].
		view dominanceTreeLayout ]! !

!RGPackageGraph methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/9/2011 11:15'!
uniqueSuccessorsPerPackage: packageName
	| uniqueSuccessors |

	uniqueSuccessors := Set new.
	(roots at: packageName)
		do:[ :root|  uniqueSuccessors addAll: root allSuccessors ].
		
	^uniqueSuccessors! !

!RGPackageGraph methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/22/2011 16:43'!
viewPackageGraph: view selectedPackages: selectedPackages
	| nodes value withAllSuccessors uniqueSuccessors |
	
	selectedPackages isEmptyOrNil
		ifTrue: [ nodes := self packageNames sort: [:e1 :e2 | e1 name <= e2 name] ]
		ifFalse:[ nodes := selectedPackages ].
	nodes do:[ :key|
		value := roots at: key.
		withAllSuccessors := self uniqueSuccessorsPerPackage: key.
		withAllSuccessors addAll: value.
		view nodeShape 
			withoutBorder;
			text: [ :each | each ].
		view node: key.
		view nodeShape withoutBorder.
		view noInteraction.
		view node: nil forIt:[
			view nodeShape
				borderColor:[ :each| each borderColorNode ];
				fillColor:[ :each| each colorNode ].
			view nodes: withAllSuccessors.
			view edges: withAllSuccessors from: [ :n| n ] toAll:[ :n | n successors ].
			view horizontalDominanceTreeLayout
			].
		view verticalLineLayout.
		 ]. ! !

Object subclass: #RGAbstractBrowser
	instanceVariableNames: 'browser model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ring-History-Browsers'!

!RGAbstractBrowser classSide methodsFor: 'opening' stamp: 'VeronicaUquillas 8/3/2011 16:29'!
open

	^self new open! !

!RGAbstractBrowser classSide methodsFor: 'opening' stamp: 'VeronicaUquillas 8/4/2011 15:17'!
open: model

	^self new 
		model: model;
		open! !

!RGAbstractBrowser methodsFor: 'accessing' stamp: 'VeronicaUquillas 7/12/2011 11:18'!
browser

	^ browser ifNil:[ self buildBrowser. browser]! !

!RGAbstractBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 7/12/2011 11:42'!
buildBrowser

	browser := GLMTabulator new.
	browser title: self titleBrowser.
	self layout! !

!RGAbstractBrowser methodsFor: 'actions' stamp: 'VeronicaUquillas 8/4/2011 14:58'!
defaultActions: anObject

	^OrderedCollection new
		add: (self inspectAction: anObject);
		yourself! !

!RGAbstractBrowser methodsFor: 'actions' stamp: 'VeronicaUquillas 8/4/2011 14:57'!
inspectAction: anObject

	^GLMGenericAction new 
		title: 'Inspect'; 
		action: [ anObject selection inspect ]; 
		yourself! !

!RGAbstractBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 7/12/2011 11:19'!
layout

	self subclassResponsibility ! !

!RGAbstractBrowser methodsFor: 'accessing' stamp: 'VeronicaUquillas 7/12/2011 11:20'!
model

	^model! !

!RGAbstractBrowser methodsFor: 'accessing' stamp: 'VeronicaUquillas 7/12/2011 11:20'!
model: anObject

	model := anObject ! !

!RGAbstractBrowser methodsFor: 'opening' stamp: 'VeronicaUquillas 7/12/2011 11:42'!
open
	
	self browser openOn: self model 
	"with: (TCMorphicRenderer new
					extent: self extent)"! !

!RGAbstractBrowser methodsFor: 'sorting' stamp: 'VeronicaUquillas 10/10/2011 16:05'!
sortByFullName: aCollection

	^ aCollection sort: [:e1 :e2 | e1 fullName <= e2 fullName ]! !

!RGAbstractBrowser methodsFor: 'sorting' stamp: 'VeronicaUquillas 8/22/2011 16:23'!
sortByName: aCollection

	^ aCollection sort: [:e1 :e2 | e1 name <= e2 name]! !

!RGAbstractBrowser methodsFor: 'sorting' stamp: 'VeronicaUquillas 8/22/2011 16:23'!
sortByTimestamp: aCollection

	^ aCollection sort: [:e1 :e2 | e1 timeStamp <= e2 timeStamp ]! !

!RGAbstractBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 7/12/2011 11:19'!
titleBrowser

	self subclassResponsibility ! !

RGAbstractBrowser subclass: #RGCommitGraphBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ring-History-Browsers'!

!RGCommitGraphBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/9/2011 13:31'!
buildBrowser

	super buildBrowser.
	self onCommits.
	self onPackages.
	self onSuccessors.
	self onCommitGraph! !

!RGCommitGraphBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/22/2011 16:57'!
layout

	browser
		column: [:c | c row: #commits span: 4; row: #packages span: 2; row: #successors ]; 
		column: #commitGraph span: 4.! !

!RGCommitGraphBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/9/2011 14:41'!
onCommitGraph

	browser
		showOn: #commitGraph;
		from: #commits;
		from: #successors;
		using: [
			browser mondrian 
				allowNil;
				painting: [ :view :commit :successor |
					self model viewCommitGraph: view selectedCommit: commit selectedSuccessor: successor]
		].
	
	"Need initial display"
	browser transmit to: #commitGraph; andShow: [:a | 
		a mondrian 
			painting: [ :view | self model viewCommitGraph: view selectedCommit: nil selectedSuccessor: nil ] ].
! !

!RGCommitGraphBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/9/2011 13:34'!
onCommits

	browser transmit
		to: #commits;
		andShow: [:a |
			a list
			title: 'Commits';
			display: [ :each| self model commitNodes ];
			format: [ :each| each name ]
		].! !

!RGCommitGraphBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/22/2011 16:29'!
onPackages

	browser transmit
		to: #packages;
		from: #commits;
		andShow: [:a |
			a list
			title: 'Packages';
			display: [ :each| self sortByName: each packages asOrderedCollection ];
			format:[ :each| each name ]
		].! !

!RGCommitGraphBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/9/2011 10:51'!
onSuccessors

	browser transmit
		to: #successors;
		from: #commits;
		andShow: [:a |
			a list
			title: 'Successors';
			display: [ :each| each successors ];
			format:[ :each| each name ]
		].! !

!RGCommitGraphBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/9/2011 10:38'!
titleBrowser

	^'Commit Evolution Graph'! !

RGAbstractBrowser subclass: #RGComparativeClassHistoryBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ring-History-Browsers'!

!RGComparativeClassHistoryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 9/9/2011 13:31'!
buildBrowser

	super buildBrowser.
	self onPackagesAndClasses.
	self onComparativeClasses! !

!RGComparativeClassHistoryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 9/9/2011 13:31'!
layout

	browser
		column: #packagesAndClasses;
		column: #comparativeHistory span: 3.! !

!RGComparativeClassHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 9/9/2011 13:32'!
onComparativeClasses

	browser
		showOn: #comparativeHistory;
		from: #packagesAndClasses;
		using: [
			browser mondrian 
				painting: [ :view :entities |
					self model viewComparativeClassesHistoryOn: view selectedEntities: entities ].
		].! !

!RGComparativeClassHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 9/22/2011 11:53'!
onPackagesAndClasses

	browser transmit
		to: #packagesAndClasses;
		andShow: [:a |
			a tree
				title: 'Packages';
				beMultiple;
				display: [ :each| self model sortedPackages ];
				icon: [ :each | each iconByStatus ];
				format:[ :each| each name ];
				children:[ :each| 
					each isPackage 
						ifTrue: [ each visibleClasses sort: each sortByName  ] ifFalse:[ #() ] ];
				dynamicActionsOnSelection: [ :each | self defaultActions: each ].
			
			a list
				title: 'Classes';
				beMultiple;
				icon: [ :each | each iconByStatus ];
				display: [ :each| self model visibleClasses sort: self model sortByName ];
				format:[ :each| each name ];
				dynamicActionsOnSelection: [ :each | self defaultActions: each ].
		].! !

!RGComparativeClassHistoryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/4/2011 16:11'!
titleBrowser

	^model timeStamp asString, ' (', model author, ')'! !

RGAbstractBrowser subclass: #RGEntityHistoryBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ring-History-Browsers'!

!RGEntityHistoryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/4/2011 15:03'!
buildBrowser

	super buildBrowser.
	self onPackages.
	self onClasses.
	self onMethods.
	self onPackageHistory.
	self onClassHistory.
	self onMethodHistory! !

!RGEntityHistoryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/4/2011 14:56'!
layout

	browser
		row: [:c | c column: #packages; column: #classes; column: #methods ]; 
		row: [:c | c column: #packageHistory; column: #classHistory; column: #methodHistory ]! !

!RGEntityHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/4/2011 14:55'!
onClassHistory

	browser
		showOn: #classHistory;
		from: #classes;
		using: [
			self onHistory
		].! !

!RGEntityHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 9/16/2011 08:16'!
onClasses

	browser transmit
		to: #classes;
		from: #packages; 
		andShow: [:a |
			a list
			title: 'Classes';
			display: [ :package| package sortedDefinedClasses ];
			icon:[ :each| each iconByStatus ];			
			format:[ :each| each name ];
			when:[ :package | package sortedDefinedClasses notEmpty ];
			dynamicActionsOnSelection: [ :each | self defaultActions: each ].
			
			a list
			title: 'Extended Classes';
			display: [ :package| package sortedExtendedClasses ];
			icon:[ :each| each iconByStatus ];			
			format:[ :each| each name ];
			when:[ :package | package sortedExtendedClasses notEmpty ];
			dynamicActionsOnSelection: [ :each | self defaultActions: each ].
		].	! !

!RGEntityHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/4/2011 15:22'!
onHistory

	browser mondrian 
		painting: [ :view :entity |
					entity viewVersionHistoryOn: view ].
! !

!RGEntityHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/4/2011 14:55'!
onMethodHistory

	browser
		showOn: #methodHistory;
		from: #methods;
		using: [
			self onHistory
		].! !

!RGEntityHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 9/16/2011 08:16'!
onMethods

	browser transmit
		to: #methods;
		from: #classes; 
		from: #packages;
		andShow: [:a |
			a list
			title: 'Methods';
			display: [ :class :pack | (class methodsInPackage: pack) sort: class sortByName  ];
			icon:[ :each| each iconByStatus ];			
			format:[ :each| each name ];
			dynamicActionsOnSelection: [ :each | self defaultActions: each ]
		].! !

!RGEntityHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/4/2011 14:55'!
onPackageHistory

	browser
		showOn: #packageHistory;
		from: #packages;
		using: [
			self onHistory
		].! !

!RGEntityHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 9/16/2011 08:15'!
onPackages

	browser transmit
		to: #packages;
		andShow: [:a |
			a list
			title: 'Packages';
			icon:[ :each| each iconByStatus ];
			display: [ :version| self model sortedPackages ];
			format:[ :each| each name ];
			dynamicActionsOnSelection: [ :each | self defaultActions: each ]
		].! !

!RGEntityHistoryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/4/2011 15:21'!
titleBrowser

	^model timeStamp asString, ' (', model author, ')'! !

RGAbstractBrowser subclass: #RGPackageGraphBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ring-History-Browsers'!

!RGPackageGraphBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/22/2011 16:11'!
buildBrowser

	super buildBrowser.
	self onPackages.
	self onRepositories.
	self onPackageGraph.! !

!RGPackageGraphBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/22/2011 16:11'!
layout

	browser
		column: [:c | c row: #packages span: 3; row: #repositories ]; 
		column: #packageGraph span: 4.! !

!RGPackageGraphBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/22/2011 16:15'!
onPackageGraph

	browser
		showOn: #packageGraph;
		from: #packages;
		using: [
			browser mondrian 
				allowNil;
				painting: [ :view :packages | 
					self model viewPackageGraph: view selectedPackages: packages ].
		].
	
	"Need initial display"
	browser transmit to: #packageGraph; andShow: [:a | 
		a mondrian 
			painting: [ :view | self model viewPackageGraph: view selectedPackages: #() ] ].! !

!RGPackageGraphBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/22/2011 16:25'!
onPackages

	browser transmit
		to: #packages;
		andShow: [:a |
			a list
			title: 'Packages';
			beMultiple;
			display: [ :each| self sortByName: (self model packageNames) ]
		].! !

!RGPackageGraphBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/8/2011 17:17'!
onRepositories

	browser transmit
		to: #repositories;
		andShow: [:a |
			a list
			title: 'Repositories';
			display: [ :each| self model repositories ];
			format:[ :each| each description ]
		].! !

!RGPackageGraphBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/22/2011 16:12'!
titleBrowser

	^'Package Evolution Graph'! !

RGAbstractBrowser subclass: #RGRepositoryHistoryBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ring-History-Browsers'!

!RGRepositoryHistoryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 7/29/2011 15:17'!
buildBrowser

	super buildBrowser.
	self onSnapshots.
	self onPackages.
	self onPackageInfo.
	self onClasses.
	self onClassDefinition.
	self onMethods.
	self onSourceCode.
	self onAssociations! !

!RGRepositoryHistoryBrowser methodsFor: 'actions' stamp: 'VeronicaUquillas 9/30/2011 15:23'!
historyAction: anObject

	^GLMGenericAction new 
		title: 'View History'; 
		action: [ anObject selection viewVersionHistory ]; 
		yourself! !

!RGRepositoryHistoryBrowser methodsFor: 'actions' stamp: 'VeronicaUquillas 9/30/2011 15:04'!
implementorsAction: anObject

	^GLMGenericAction new 
		title: 'Implementors'; 
		action: [ anObject selection viewImplementorsMap ]; 
		yourself! !

!RGRepositoryHistoryBrowser methodsFor: 'importing- to remove' stamp: 'VeronicaUquillas 7/12/2011 14:22'!
importHistory
	| repository importer |

	repository := MCHttpRepository location:'http://www.squeaksource.com/Ring' user:'' password:''.
	
	RGHistoryRepository current clear.
	importer := RGHistoryImporterMonticello onRepository:  repository.
	importer toImport: 'Ring-*'; excluding: #('*-core' '*-FileContents').
	importer import.
	
	^RGHistoryRepository current ! !

!RGRepositoryHistoryBrowser methodsFor: 'initialize-release' stamp: 'VeronicaUquillas 7/12/2011 13:57'!
initialize 

	super initialize.
	self model: "self importHistory"  RGHistoryRepository current! !

!RGRepositoryHistoryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/4/2011 15:01'!
layout

	browser
		column: #snapshots; 
		column: [:c | c row: #packages span: 3; row: #packageInfo ]; 
		column: [:c | c row: #classes span: 2; row: #classDefinition ];
		column: [:c | c row: #methods; row: #sourceCode; row: #associations ]! !

!RGRepositoryHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 10/21/2011 15:14'!
onAssociations
	| innerBrowser |
	
"	innerBrowser:= GLMTabulator new.
	innerBrowser row: #invocations; row: #accesses; row: #references."
	innerBrowser := GLMStacker new.
	innerBrowser aPane: #invocations; aPane: #accesses; aPane: #references; aPane: #senders; aPane: #implementors.
	innerBrowser transmit to: #invocations; fromOutside: #entity; andShow: [:a | 
			a title: 'Invocations'.
			a  list
				display: [ :mth| self sortByName: mth invocations  ];
				format:[ :each| each message ] ].
	innerBrowser transmit to: #accesses; fromOutside: #entity; andShow: [:a | 
			a title: 'Accesses'.
			a list				
				display: [ :mth| self sortByName: mth accesses ];
				format:[ :each| each labelForView ] ].
	innerBrowser transmit to: #references; fromOutside: #entity; andShow: [:a | 
			a title: 'References'.
			a list
				display: [ :mth| self sortByName: mth references ];
				format:[ :each| each targetName ] ].
	innerBrowser transmit to: #senders; fromOutside: #entity; andShow: [:a | 
			a title: 'Senders'.
			a list
				display: [ :mth| mth senders ];
				format:[ :each| each fullName ] ].
	innerBrowser transmit to: #implementors; fromOutside: #entity; andShow: [:a | 
			a title: 'Implementors'.
			a list
				display: [ :mth| self sortByName: mth implementors ];
				format:[ :each| each name ] ].
			 
	browser
		showOn: #associations;
		from: #methods;
		using: [
			browser custom: innerBrowser ]! !

!RGRepositoryHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 10/18/2011 10:11'!
onClassDefinition

	browser
		showOn: #classDefinition;
		from: #classes;
		using: [
		browser text
			title: 'Definition';
			display: [ :cls| cls definitionSource, String crlfcrlf, cls theMetaClass definitionSource ];
			when: [ :cls| cls isMeta not and:[ cls package isExternal not ] ].

		browser text
			title: 'Comment';
			display: [ :cls| cls comment content ];
			when:[ :cls| cls isMeta not and:[ cls hasComment ] ]
		].! !

!RGRepositoryHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 9/30/2011 15:24'!
onClasses

	browser transmit
		to: #classes;
		from: #packages; 
		andShow: [:a |
			a list
			title: 'Classes';
			display: [ :package| package sortedDefinedClasses ];
			format:[ :each| each name ];
			when:[ :package | package sortedDefinedClasses notEmpty ];
			dynamicActionsOnSelection: [ :each | 
				(self defaultActions: each)
					add: (self historyAction: each);
					yourself ].
			
			a list
			title: 'Extended Classes';
			display: [ :package| package sortedExtendedClasses ];
			format:[ :each| each name ];
			when:[ :package | package sortedExtendedClasses notEmpty ];
			dynamicActionsOnSelection: [ :each | 
				(self defaultActions: each)
					add: (self historyAction: each);
					yourself ].
		].! !

!RGRepositoryHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 9/30/2011 15:24'!
onMethods

	browser transmit
		to: #methods;
		from: #classes; 
		from: #packages;
		andShow: [:a |
			a list
			title: 'Methods';
			display: [ :class :pack | (class methodsInPackage: pack) sort: class sortByName  ];
			format:[ :each| each name ];
			dynamicActionsOnSelection: [ :each | 
				(self defaultActions: each) 
					add: (self historyAction: each);
					add: (self sendersAction: each); 
					add: (self implementorsAction: each);
					yourself ]
		].! !

!RGRepositoryHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/3/2011 16:43'!
onPackageInfo

	browser
		transmit to: #packageInfo;
		from: #packages;
		andShow: [:a | 
			a text display: [ :each | each summary ]
		].! !

!RGRepositoryHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 9/30/2011 15:24'!
onPackages

	browser transmit
		to: #packages;
		from: #snapshots; 
		andShow: [:a |
			a list
			title: 'Packages';
			display: [ :version| version sortedPackages ];
			format:[ :each| each name ];
			dynamicActionsOnSelection: [ :each | 
				(self defaultActions: each)
					add: (self historyAction: each);
					yourself ]
		].! !

!RGRepositoryHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 11/14/2011 22:05'!
onSnapshots

	browser
		showOn: #snapshots;
		using: [
		browser list
			title: 'Snapshots';
			display: self model topologicallySortedSnapshots reversed;
			format:[ :each| each name ];
			dynamicActionsOnSelection: [ :each | (self defaultActions: each) 
														add: (self viewHistoryAction: each); 
														add: (self viewComparativeClassesAction: each);
													yourself ]
		].! !

!RGRepositoryHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 10/5/2011 17:08'!
onSourceCode

	browser
		showOn: #sourceCode;
		from: #methods;
		using: [
		browser text
			"title: 'SourceCode';"
			display: [ :mth| mth sourceCode ];
			forSmalltalk: [ :mth| mth parent ].
		].! !

!RGRepositoryHistoryBrowser methodsFor: 'actions' stamp: 'VeronicaUquillas 9/30/2011 15:04'!
sendersAction: anObject

	^GLMGenericAction new 
		title: 'Senders'; 
		action: [ anObject selection viewSendersMap ]; 
		yourself! !

!RGRepositoryHistoryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/3/2011 17:29'!
titleBrowser

	^self model description! !

!RGRepositoryHistoryBrowser methodsFor: 'actions' stamp: 'VeronicaUquillas 8/8/2011 13:03'!
viewComparativeClassesAction: anObject

	^GLMGenericAction new 
		title: 'View Comparative Classes'; 
		action: [ RGComparativeClassHistoryBrowser open: anObject selection ]; 
		yourself! !

!RGRepositoryHistoryBrowser methodsFor: 'actions' stamp: 'VeronicaUquillas 8/4/2011 15:16'!
viewHistoryAction: anObject

	^GLMGenericAction new 
		title: 'View History'; 
		action: [ RGEntityHistoryBrowser open: anObject selection ]; 
		yourself! !

RGAbstractBrowser subclass: #RGSnapshotDeltaBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ring-History-Browsers'!

!RGSnapshotDeltaBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 10/10/2011 15:57'!
buildBrowser

	super buildBrowser.
	self onChangesPerType.
	self onChange! !

!RGSnapshotDeltaBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 10/10/2011 16:45'!
layout

	browser
		column: #changesPerType; 
		column: #change span: 2! !

!RGSnapshotDeltaBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 10/10/2011 16:57'!
onChange

	browser
		showOn: #change;
		from: #changesPerType;
		using: [
			browser diff
				title: 'Class Definition Diff';
				display: [ :each | { each obsoleteEntity definitionSource . each substituteEntity definitionSource } ];
				when: [ :each | each hasChangedDefinitionSource ].
			browser text
				title: 'Class Definition';
				forSmalltalk:[  :each | each entity ];
				when: [ :each | each isClassChange and:[ each hasChangedDefinitionSource not ] ];
				display: [ :each | each entity definitionSource ifNil:[ '<extended class>'] ].
				
			browser diff
				title: 'Source Code Diff';
				display: [ :each | { each obsoleteEntity sourceCode . each substituteEntity sourceCode } ];
				when: [ :each | each hasChangedSourceCode ].
			browser text
				title: 'Source Code';
				forSmalltalk:[  :each | each entity parent ];
				when: [ :each | each isMethodChange and:[ each hasChangedSourceCode not ] ];
				display: [ :each | each entity sourceCode ].
		].! !

!RGSnapshotDeltaBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 10/10/2011 16:10'!
onChangesPerType

	browser
		showOn: #changesPerType;
		using: [
		browser tree
			title: 'Changes per Entity Type';
			display: [ :each| self model entityTypes keys sort ];
			icon: [ :each | 
				each isSymbol 
					ifTrue: [ nil ]
					ifFalse:[ each icon ] ];
			children:[ :each| 
				each isSymbol
					ifTrue: [ self sortByFullName: (self model changesByEntityType: (self model entityTypes at: each)) ]
					ifFalse:[ {} ] ];
			format: [ :each| 
				each isSymbol 
					ifTrue: [ each ]
					ifFalse:[ each fullName ] ]
		].! !

!RGSnapshotDeltaBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 10/10/2011 15:02'!
titleBrowser

	^self model description! !

RGAbstractBrowser subclass: #RGSnapshotDeltaHistoryBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ring-History-Browsers'!

!RGSnapshotDeltaHistoryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 11/10/2011 12:32'!
buildBrowser

	super buildBrowser.
	self onDeltas.
	self onBaseOfDelta.
	self onTargetOfDelta.
	self onDependenciesPerDelta.
	self onChangesPerDelta.
	self onSourceCode.
	self onDependenciesPerChange.! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/10/2011 13:38'!
dependenciesOfChange: change in: delta

	^ (delta dependencies detect:[ :each| each change = change ] ifNone:[ nil ])
		ifNotNil: [ :dep| dep dependenciesMap ]
		ifNil:[ #() ]! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 11/10/2011 12:31'!
layout

	browser
		column: [ :c| c row: #deltas span: 2; row: [:r | r column: #baseOfDelta; column: #targetOfDelta ]; row: #dependenciesOfDelta ];
		column: [ :c| c row: [:r | r column: #changesOfDelta; column: #sourceCode ]; 
					   row: #dependenciesOfChange ] span: 1.5! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 11/10/2011 12:45'!
onBaseOfDelta

	browser
		showOn: #baseOfDelta;
		from: #deltas;
		using: [
		browser list
			title: 'Base Snapshot Packages';
			display: [ :each| each base packagesButExternal ];
			format:[ :each| each versionName ];
			when:[ :each| each base isNilHistory not ];
			dynamicActionsOnSelection: [ :each | (self defaultActions: each) ].
		].! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 11/14/2011 21:09'!
onChangesPerDelta

	browser
		showOn: #changesOfDelta;
		from: #deltas;
		using: [
		browser list
			title: 'Changes with Dependencies';
			display:[ :each| self sortByFullName: (each dependentChanges) ];
			format:[ :each| each fullName ];
			icon: [ :each | each icon ];
			when:[ :each| each dependentChanges notEmpty ];
			dynamicActionsOnSelection: [ :each | (self defaultActions: each) ].
		browser list
			title: 'Changes without Dependencies';
			display:[ :each| self sortByFullName: (each nonDependentChanges) ];
			format:[ :each| each fullName ];
			icon: [ :each | each icon ];
			when:[ :each| each nonDependentChanges notEmpty ];
			dynamicActionsOnSelection: [ :each | (self defaultActions: each) ]
		].! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 11/14/2011 22:20'!
onDeltas

	browser
		showOn: #deltas;
		using: [
		browser list
			title: 'Deltas';
			display: (self model sortDeltas: self model deltas);
			format:[ :each| each name ];
			dynamicActionsOnSelection: [ :each | (self defaultActions: each) ]
		].! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 11/10/2011 19:12'!
onDependenciesPerChange

	browser
		showOn: #dependenciesOfChange;
		from: #changesOfDelta;
		from: #deltas;
		using: [
		browser tree
			title: 'Change Dependencies';
			allExpanded;
			when:[ :change :delta| (self dependenciesOfChange: change in: delta) notEmpty ];
			display:[ :change :delta| (self dependenciesOfChange: change in: delta) keys ];
			icon:[ :each | 
				((each isKindOf: Association) and:[ each key isSymbol not ]) ifTrue:[ each key icon ] ifFalse:[ nil ] ];
			format:[ :each| each isSymbol
							ifTrue:[ each ]
							ifFalse:[
								(each isKindOf: Association) 
									ifTrue: [ each value isNil ifTrue: [ each key ] ifFalse:[ each key fullName, ' [', each value name, ']' ] ]
									ifFalse:[ each ] ] ];
			children:[ :each :change :delta| | dep value |
				dep := self dependenciesOfChange: change in: delta.
				each isSymbol 
					ifTrue: [ 
						(dep includesKey: each) 
							ifTrue: [ value := dep at: each. 
									each = #references 
										ifTrue: [ value := value values ].
									value isDictionary 
										ifTrue: [ value keys asSortedCollection ] 
										ifFalse:[ value asOrderedCollection ] ]
							ifFalse:[ (value := dep values detect:[ :sub| sub isDictionary and:[ sub includesKey: each ] ] ifNone:[ nil ]) isNil
										ifTrue: [ #() ]
										ifFalse:[ (value at: each) value isNil ifTrue:[ #() ] ifFalse:[ self sortAssociationsByFullName: ((value at: each) asOrderedCollection) ] ] ] ]
					ifFalse:[ #() ] ];
			dynamicActionsOnSelection: [ :each | (self defaultActions: each) ].
	]! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 11/14/2011 22:54'!
onDependenciesPerDelta

	browser
		showOn: #dependenciesOfDelta;
		from: #deltas;
		using: [
		browser list
			title: 'Needed Deltas';
			display:[ :delta| self model sortDeltas: delta neededDeltas ];
			format:[ :each| each name ];
			when:[ :each| each neededDeltas notEmpty ];
			dynamicActionsOnSelection: [ :each | (self defaultActions: each) ].
		browser list
			title: 'Potentially Needed Deltas';
			display:[ :delta| self model sortDeltas: delta potentitallyFuzzyDeltas ];
			format:[ :each| each name ];
			when:[ :each| each potentitallyFuzzyDeltas notEmpty ];
			dynamicActionsOnSelection: [ :each | (self defaultActions: each) ].
		browser list
			title: 'External Dependencies';
			display:[ :delta| self sortByName: (delta externalDependents asOrderedCollection) ];
			format:[ :each| each ];
			when:[ :each| each externalDependents notEmpty ];
			dynamicActionsOnSelection: [ :each | (self defaultActions: each) ]
		].! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 11/3/2011 16:45'!
onSourceCode

	browser
		transmit to: #sourceCode;
		from: #changesOfDelta;
		andShow: [ :a|
			a smalltalkCode 
				title: 'Source Code';
				display: [ :each| 
					each isMethodChange 
						ifTrue: [ each entity sourceCode ]
						ifFalse:[ each entity definitionSource ] ];
				smalltalkClass: [ :each| 
					each isMethodChange 
						ifTrue: [ each entity parent ]
						ifFalse:[ each entity ] ].
			]! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 11/10/2011 12:45'!
onTargetOfDelta

	browser
		showOn: #targetOfDelta;
		from: #deltas;
		using: [
		browser list
			title: 'Target Snapshot Packages';
			display: [ :each| each target packagesButExternal ];
			format:[ :each| each versionName ];
			dynamicActionsOnSelection: [ :each | (self defaultActions: each) ]
		].! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'sorting' stamp: 'VeronicaUquillas 11/10/2011 12:49'!
sortAssociationsByFullName: aCollection

	^ aCollection sort: [:e1 :e2 | e1 key fullName <= e2 key fullName ]! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 10/19/2011 10:35'!
titleBrowser

	^ 'Snapshot Delta History'! !

RGAbstractBrowser subclass: #RGSnapshotGraphBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ring-History-Browsers'!

!RGSnapshotGraphBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/9/2011 16:51'!
buildBrowser

	super buildBrowser.
	self onSnapshots.
	self onPackages.
	self onSuccessors.
	self onSnapshotGraph ! !

!RGSnapshotGraphBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/9/2011 16:49'!
layout

	browser
		column: [:c | c row: #snapshots span: 3; row: #packages; row: #successors ]; 
		column: #snapshotGraph span: 4.! !

!RGSnapshotGraphBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/22/2011 16:31'!
onPackages

	browser transmit
		to: #packages;
		from: #snapshots;
		andShow: [:a |
			a list
			title: 'Packages';
			display: [ :each| self sortByName: each packages asOrderedCollection ];
			format:[ :each| each name ]
		].! !

!RGSnapshotGraphBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/9/2011 16:50'!
onSnapshotGraph

	browser
		showOn: #snapshotGraph;
		from: #snapshots;
		from: #successors;
		using: [
			browser mondrian 
				allowNil;
				painting: [ :view :snapshot :successor |
					self model viewSnapshotGraph: view selectedSnapshot: snapshot selectedSuccessor: successor]
		].
	
	"Need initial display"
	browser transmit to: #snapshotGraph; andShow: [:a | 
		a mondrian 
			painting: [ :view | self model viewSnapshotGraph: view selectedSnapshot: nil selectedSuccessor: nil ] ].
! !

!RGSnapshotGraphBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/9/2011 16:50'!
onSnapshots

	browser transmit
		to: #snapshots;
		andShow: [:a |
			a list
			title: 'Snapshots';
			display: [ :each| self model snapshots ];
			format: [ :each| each name ]
		].! !

!RGSnapshotGraphBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/9/2011 16:56'!
onSuccessors

	browser transmit
		to: #successors;
		from: #snapshots;
		andShow: [:a |
			a list
			title: 'Successors';
			display: [ :each| each successors ];
			format:[ :each| each name ]
		].! !

!RGSnapshotGraphBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/9/2011 16:51'!
titleBrowser

	^'Snapshot Evolution Graph'! !

!RGSnapshotGraph methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/22/2011 17:55'!
viewSnapshotGraph: view selectedSnapshot: selectedSnapshot selectedSuccessor: selectedSuccessor

	view nodeShape
		borderColor: [ :each| each borderColorNode: (selectedSnapshot ifNil:[ #() ] ifNotNil:[ :s| s successors ]) ];
		fillColor:[ :each| each colorNode: selectedSnapshot successor: selectedSuccessor ].
	view nodes: self snapshots forEach:[ :snap|
		view nodeShape
			borderColor:[ :each| each borderColorNode ];
			fillColor:[ :each| each colorNode ].
		view nodes: snap commit packages.
		view nodeShape
			borderStyle:[ :each| BorderStyle dashed ];
			borderColor:[ :each| each borderColorNode ];
			fillColor:[ :each| each colorNode ]. 
		view nodes: snap nonCommitPackages.
		view flowLayout maxWidth: 40 ].
	view edges: self snapshots from: [ :n| n ] toAll:[ :n | n successors ].
	view horizontalDominanceTreeLayout 
		verticalGap: 8! !
